Highlights:
   - **Bug fixes**
      - Fix macro error with ti_import_cpu_memory (#8401) (by **Zhanlue Yang**)
      - Fix argpack nesting issues (by **listerily**)
      - Convert matrices to structs in argpack type members, Fixing layout error (by **listerily**)
      - Fix error when returning a struct field member when the return … (#8271) (by **秋云未云**)
      - Fix Erroneous handling of ndarray in real function in CFG (#8245) (by **Lin Jiang**)
      - Fix issue with passing python-scope Matrix as ti.func argument (#8197) (by **Zhanlue Yang**)
      - Fix incorrect CFG Graph structure due to missing Block wiith OffloadedStmts on LLVM backend (#8113) (by **Zhanlue Yang**)
      - Fix type inference error with LowerMatrixPtr pass (#8105) (by **Zhanlue Yang**)
      - Set initial value for Cuda device allocation (#8063) (by **Zhanlue Yang**)
      - Fix the insertion position of the access chain (#7957) (by **Lin Jiang**)
      - Fix wrong datatype size when writing to ndarray from Python scope (by **Ailing Zhang**)
   - **CUDA backend**
      - Warn driver version if it doesn't support memory pool. (#7912) (by **Haidong Lan**)
   - **Documentation**
      - Update the doc of real functions (#8412) (by **Lin Jiang**)
      - Remove the limit on kernel argument size (#8408) (by **Lin Jiang**)
      - Fixing typo in impl.py on ti.grouped function documentation (#8407) (by **Quentin Warnant**)
      - Update doc about kernels and functions (#8400) (by **Lin Jiang**)
      - Update documentation (#8089) (by **Zhao Liang**)
      - Update docstring for inverse func (#8170) (by **Zhao Liang**)
      - Update type.md, add descriptions of the vector (#8048) (by **Chenzhan Shang**)
      - Fix a bug in faq.md (#7992) (by **Zhao Liang**)
      - Fix problems in type_system.md (#7949) (by **秋云未云**)
      - Add doc about struct arguments (#7959) (by **Lin Jiang**)
      - Fix docstring of mix function (#7922) (by **Zhao Liang**)
      - Update faq and ggui, and add them to CI (#7861) (by **Zhao Liang**)
      - Add kernel sync doc (#7831) (by **Zhao Liang**)
   - **Error messages**
      - Warn before calling the external function (#8177) (by **Lin Jiang**)
      - Add option to print full traceback in Python (#8160) (by **Lin Jiang**)
      - Let to_primitive_type throw an error if the type is a pointer (by **lin-hitonami**)
      - Update deprecation warning of the graph arguments (#7965) (by **Lin Jiang**)
   - **Language and syntax**
      - Remove deprecated graph arguments (#8410) (by **Lin Jiang**)
      - Deprecate ti.experimental.real_func (#8409) (by **Lin Jiang**)
      - Add clz instruction (#8276) (by **Jett Chen**)
      - Move real function out of the experimental module (#8399) (by **Lin Jiang**)
      - Fix error with loop unique analysis for MatrixPtrStmt (#8307) (by **Zhanlue Yang**)
      - Pass DebugInfo from Python to C++ for ndarray and field (#8286) (by **魔法少女赵志辉**)
      - Support TensorType for SharedArray (#8258) (by **Zhanlue Yang**)
      - Use ErrorEmitter in type check passes (#8285) (by **魔法少女赵志辉**)
      - Implement struct DebugInfo and ErrorEmitter (#8284) (by **魔法少女赵志辉**)
      - Add TensorType support for Constant Folding (#8250) (by **Zhanlue Yang**)
      - Support TensorType for irpass::alg_simp() (#8225) (by **Zhanlue Yang**)
      - Support vector/matrix ndarray arguments in real function (by **Lin Jiang**)
      - Fix error on ndarray type check (by **Lin Jiang**)
      - Support real function in data-oriented classes (by **lin-hitonami**)
      - Let kernel support return type annotated with 'typing.Tuple' (by **lin-hitonami**)
      - Support tuple return value for kernel and real function (by **lin-hitonami**)
      - Let static assert be in static scope (#8217) (by **Lin Jiang**)
      - Avoid scalarization for AOS GlobalPtrStmt (#8187) (by **Zhanlue Yang**)
      - Support matrix return value for real function (by **lin-hitonami**)
      - Support ndarray argument for real function (by **lin-hitonami**)
      - Cast the scalar arguments and return values of ti.func if the type hints exist (#8193) (by **Lin Jiang**)
      - Handle MatrixPtrStmt for uniquely_accessed_pointers() (#8165) (by **Zhanlue Yang**)
      - Support struct arguments for real function (by **lin-hitonami**)
      - Merge irpass::half2_vectorize() with irpass::scalarize() (#8102) (by **Zhanlue Yang**)
      - Migrate irpass::scalarize() after optimize_bit_struct_stores & determine_ad_stack_size (#8097) (by **Zhanlue Yang**)
      - Migrate irpass::scalarize() after irpass::demote_operations() (#8096) (by **Zhanlue Yang**)
      - Migrate irpass::scalarize() after irpass::lower_access() (#8091) (by **Zhanlue Yang**)
      - Migrate irpass::scalarize() after irpass::make_block_local() (#8090) (by **Zhanlue Yang**)
      - Support TensorType for Dead-Store-Elimination (#8065) (by **Zhanlue Yang**)
      - Optimize alias checking conditions for store-to-load forwarding (#8079) (by **Zhanlue Yang**)
      - Support TensorType for Load-Store-Forwarding (#8058) (by **Zhanlue Yang**)
      - Fix TensorTyped error with irpass::make_thread_local() (#8051) (by **Zhanlue Yang**)
      - Fix numerical issue with auto_diff() (#8025) (by **Zhanlue Yang**)
      - Migrate irpass::scalarize() after irpass::make_mesh_block_local() (#8030) (by **Zhanlue Yang**)
      - Migrate irpass::scalarize() after irpass::make_thread_local() (#8028) (by **Zhanlue Yang**)
      - Support allocate with cuda memory pool and reduce preallocation size accordingly (#7929) (by **Zhanlue Yang**)
      - Migrate irpass::scalarize() after irpass::demote_no_access_mesh_fors() (#7956) (by **Zhanlue Yang**)
      - Fix error with irpass::check_out_of_bound() for TensorTyped ExternalPtrStmt (#7997) (by **Zhanlue Yang**)
      - Migrate irpass::scalarize() after irpass::demote_atomics() (#7943) (by **Zhanlue Yang**)
      - Separate out preallocation logics for runtime objects (#7938) (by **Zhanlue Yang**)
      - Remove deprecated funcs in __init__.py (#7941) (by **Lin Jiang**)
      - Remove deprecated sparse_matrix_builder function (#7942) (by **Lin Jiang**)
      - Remove deprecated compile option ndarray_use_cached_allocator (#7937) (by **Zhanlue Yang**)
      - Migrate irpass::scalarize() after irpass::detect_read_only() (#7939) (by **Zhanlue Yang**)
      - Remove deprecated funcs in ti.ui (#7940) (by **Lin Jiang**)
      - Remove the support for 'is' (#7930) (by **Lin Jiang**)
      - Migrate irpass::scalarize() after irpass::offload() (#7919) (by **Zhanlue Yang**)
      - Raise error when the dimension of the ndrange does not equal to the number of the loop variable (#7933) (by **Lin Jiang**)
      - Remove a.atomic(b) (#7925) (by **Lin Jiang**)
      - Cancel deprecating native min/max (#7928) (by **Lin Jiang**)
      - Fix the api doc search problem (#7918) (by **Zhao Liang**)
      - Move irpass::scalarize() after irpass::auto_diff() (#7902) (by **Zhanlue Yang**)
      - Fix Ndarray fill with Matrix/Vector typed values (#7901) (by **Zhanlue Yang**)
      - Add cast to field.fill() interface (#7899) (by **Zhanlue Yang**)
      - Let nested data classes have methods (#7909) (by **Lin Jiang**)
      - Let kernel argument support matrix nested in a struct (by **lin-hitonami**)
      - Support the functions of dataclass as kernel argument and return value (#7865) (by **Lin Jiang**)
      - Fix a bug on PosixPath (#7860) (by **Zhao Liang**)
      - Postpone MatrixType scalarization to irpass::differentiation_validation_check() (#7839) (by **Zhanlue Yang**)
      - Postpone MatrixType scalarization to irpass::gather_meshfor_relation_types() (#7838) (by **Zhanlue Yang**)
   - **Miscellaneous**
      - Make clang-tidy happy on 'explicit' (#7999) (by **秋云未云**)
   - **OpenGL backend**
      - Fix: runtime caught error cannot be displayed in opengl (#7998) (by **秋云未云**)
   - **IR optimization passes**
      - Make merging casts int(int(x)) less aggressive (#7944) (by **Ailing**)
      - Fix redundant clone of stmts across offloaded tasks (#7927) (by **Ailing**)
   - **Refactor**
      - Refactor the argument passing logic of rwtexture and remove extra_args (#7914) (by **Lin Jiang**)

Full changelog:
   - [build] Temporarily switch to clang-14 (#8419) (by **Proton**)
   - [aot] Remove taichi c-api version log (#8415) (by **Sichao He**)
   - [misc] Downgrade clang version to 14.0.6 on CI (#8417) (by **Zhanlue Yang**)
   - [Lang] Remove deprecated graph arguments (#8410) (by **Lin Jiang**)
   - [Doc] Update the doc of real functions (#8412) (by **Lin Jiang**)
   - [Doc] Remove the limit on kernel argument size (#8408) (by **Lin Jiang**)
   - [Lang] Deprecate ti.experimental.real_func (#8409) (by **Lin Jiang**)
   - [Doc] Fixing typo in impl.py on ti.grouped function documentation (#8407) (by **Quentin Warnant**)
   - [aot] Fix missing .so in manylinux2014 environment (#8404) (by **Sichao He**)
   - [bug] Fix argpack with struct and vector (#8403) (by **Lin Jiang**)
   - [Doc] Update doc about kernels and functions (#8400) (by **Lin Jiang**)
   - [Bug] Fix macro error with ti_import_cpu_memory (#8401) (by **Zhanlue Yang**)
   - [Lang] [ir] [cuda] Add clz instruction (#8276) (by **Jett Chen**)
   - [Lang] Move real function out of the experimental module (#8399) (by **Lin Jiang**)
   - [gui] Restore make_camera API (as a helper function) (#8397) (by **Bob Cao**)
   - [simt] Support "__syncthreads_and", "__syncthreads_or", and "__syncthreads_count" from CUDA. (#8297) (by **wanmeihuali**)
   - [bug] Fix optimization of exp with negative exponent (#8398) (by **Lin Jiang**)
   - [bug] Fix crashing when a SNode is destroyed after taichi resets (#8393) (by **Lin Jiang**)
   - [aot] Import CPU and CUDA memory for Taichi AOT (#8372) (by **Sichao He**)
   - [bug] Fix missing taichi_common symbol in gfx_runtime (#8362) (by **Ailing**)
   - [aot] Support multiple AOT runtime devices (#8275) (by **PENGUINLIONG**)
   - [gui] Metal GGUI support & run metal ggui tests (#8343) (by **Bob Cao**)
   - [rhi] Update RHI examples (#8331) (by **Antonio Ferreras**)
   - [rhi] Metal RHI buffer-image copying (#8329) (by **Antonio Ferreras**)
   - [rhi] Metal backend raster support (#8324) (by **Antonio Ferreras**)
   - [vulkan] Fix shared memory atomic float operations (#8315) (by **Bob Cao**)
   - [Lang] Fix error with loop unique analysis for MatrixPtrStmt (#8307) (by **Zhanlue Yang**)
   - [lang] Enhance matrixfree solver user experience (#8309) (by **Yu Zhang**)
   - [rhi] MetalCommandList store unique_ptr to resource set (#8312) (by **Antonio Ferreras**)
   - [bug] Remove extra dbg_info_printer (#8310) (by **魔法少女赵志辉**)
   - [lang] Pass DebugInfo to frontend expressions (#8308) (by **魔法少女赵志辉**)
   - [gui] Fix vec_to_euler that breaks GGUI cameras & handle camera logic better (#8304) (by **Bob Cao**)
   - [misc] Better error msg when calling kernels & calling python funcs (#8186) (by **Bob Cao**)
   - [aot] Fix 140 convention to match master (#8306) (by **Ailing**)
   - [lang] Add compile config flag to print DebugInfo when printing ir (#8303) (by **魔法少女赵志辉**)
   - [bug] Fix dataclass support for struct with matrix (#8251) (by **Ailing**)
   - [example] Eliminate NANs in mpm examples (#8260) (by **Yu Zhang**)
   - [lang] Fix MPS / other torch backend `from_torch` (#8298) (by **Bob Cao**)
   - [rhi] Add MetalPipeline raster support and MetalRasterResources (#8299) (by **Antonio Ferreras**)
   - [lang] Pass DebugInfo to frontend statements (#8295) (by **魔法少女赵志辉**)
   - [bug] Fix cusolver load failure caused by version difference (#8283) (by **Qian Bao**)
   - [bug] Remove debug print (#8296) (by **魔法少女赵志辉**)
   - [lang] Passing DebugInfo instead of std::string traceback (#8293) (by **魔法少女赵志辉**)
   - [bug] Fix mmwrite format. (#8292) (by **Qian Bao**)
   - [Lang] Pass DebugInfo from Python to C++ for ndarray and field (#8286) (by **魔法少女赵志辉**)
   - [Lang] Support TensorType for SharedArray (#8258) (by **Zhanlue Yang**)
   - [bug] Fix build.py Powershell part. (#8291) (by **Qian Bao**)
   - [Lang] Use ErrorEmitter in type check passes (#8285) (by **魔法少女赵志辉**)
   - [Lang] Implement struct DebugInfo and ErrorEmitter (#8284) (by **魔法少女赵志辉**)
   - [doc] Update argument pack docs (#8279) (by **秋云未云**)
   - [example] Add real func version of cornell box (by **lin-hitonami**)
   - [bug] Fix the continue statement in real function (by **lin-hitonami**)
   - [bug] Let the outermost for loop in real function breakable (by **lin-hitonami**)
   - [rhi] MetalSurface functions (#8274) (by **Antonio Ferreras**)
   - [lang] Check ndarray shape in Python constructor (#8272) (by **魔法少女赵志辉**)
   - [refactor] Refactor code repetition for get argpack layout (#8278) (by **秋云未云**)
   - [lang] [ir] Support argpack nesting (by **listerily**)
   - [llvm] [ir] Implemented argpack buffer load on llvm devices (by **listerily**)
   - [lang] Argpacks stores scalar values only in cpp implementation, and passes ndarray values by 'virtual parameters' (by **listerily**)
   - [lang] Feat: using magic number 32 to limit loop unrolling (#8169) (by **Garry Ling**)
   - [test] Revert skipped argpack tests (spir-v backends only) (by **listerily**)
   - [Bug] Fix argpack nesting issues (by **listerily**)
   - [spirv] [ir] Support argpack buffer load for spir-v backends (by **listerily**)
   - [Bug] Convert matrices to structs in argpack type members, Fixing layout error (by **listerily**)
   - [lang] Add arg_depth property to Expressions and Statements (by **listerily**)
   - [lang] Add is_argpack property to Argument (by **listerily**)
   - [bug] Fix indexing crash in TaskCodeGenLLVM::get_struct_arg (by **listerily**)
   - [lang] Add read and write methods to ArgPack (by **listerily**)
   - [lang] Instantiate a runtime ArgPack object when a python ArgPack is created (by **listerily**)
   - [refactor] Renamed allocate_memory_ndarray to allocate_memory_on_device (by **listerily**)
   - [lang] Link cpp ArgPackType object to python ArgPackType (by **listerily**)
   - [lang] Add cpp impl of ArgPackType (by **listerily**)
   - [refactor] Enhance argument data structures, replacing vector styled arguments with nestable styled arguments (by **listerily**)
   - [refactor] Make arg_id a vector (by **listerily**)
   - [Bug] Fix error when returning a struct field member when the return … (#8271) (by **秋云未云**)
   - [refactor] Add base class GfxProgramImpl (by **listerily**)
   - [Lang] Add TensorType support for Constant Folding (#8250) (by **Zhanlue Yang**)
   - [autodiff] Fix loop index not stored (#8200) (by **Mingrui Zhang**)
   - [Bug] Fix Erroneous handling of ndarray in real function in CFG (#8245) (by **Lin Jiang**)
   - [bug] Add is_grad to printer of ExternalTensorBasePtrExpression/Stmt (#8244) (by **Lin Jiang**)
   - [gui] Doc updates for SceneV2 (#8234) (by **Antonio Ferreras**)
   - [Lang] Support TensorType for irpass::alg_simp() (#8225) (by **Zhanlue Yang**)
   - [example] Add real func ver of stable_fluid_graph (by **Lin Jiang**)
   - [Lang] Support vector/matrix ndarray arguments in real function (by **Lin Jiang**)
   - [Lang] [bug] Fix error on ndarray type check (by **Lin Jiang**)
   - [gui] Remove cached arrays (#8223) (by **Antonio Ferreras**)
   - [gui] Tests for scenev2 (#8222) (by **Antonio Ferreras**)
   - [aot] Fix bug in compute graph jit (#8238) (by **Chenzhan Shang**)
   - [aot] Support matrix/vector for compute graph in C-API (#8228) (by **Chenzhan Shang**)
   - [aot] Support matrix/vector for compute graph in Python (#8198) (by **Chenzhan Shang**)
   - [gui] SceneV2 for a more efficient/cleaner implementation of Scene (#8205) (by **Antonio Ferreras**)
   - [example] Add real func ver of taichi_ngp (by **lin-hitonami**)
   - [Lang] Support real function in data-oriented classes (by **lin-hitonami**)
   - [Lang] Let kernel support return type annotated with 'typing.Tuple' (by **lin-hitonami**)
   - [example] Add real function ver of poisson_disk_sampling (by **lin-hitonami**)
   - [Lang] Support tuple return value for kernel and real function (by **lin-hitonami**)
   - [lang] Remove useless insertion to global_vars (by **lin-hitonami**)
   - [ir] Add lower_matrix_ptr pass to compile_function and move scalarize to the end (by **lin-hitonami**)
   - [Lang] [bug] Let static assert be in static scope (#8217) (by **Lin Jiang**)
   - [build] Fix build of RHI examples (temporarily) (#8213) (by **Bob Cao**)
   - [ci] Add taichiCourse01 & marching_squares release tests (#8157) (by **Xinhao Yuan**)
   - [llvm] Allocate the buffers of the real function in the entry block (#8206) (by **Lin Jiang**)
   - [Lang] Avoid scalarization for AOS GlobalPtrStmt (#8187) (by **Zhanlue Yang**)
   - [lang] Add matrixfree BICGSTAB solver (#8196) (by **Qian Bao**)
   - [bug] Fix incorrect error message in checking matrix shape (#8201) (by **秋云未云**)
   - [Bug] Fix issue with passing python-scope Matrix as ti.func argument (#8197) (by **Zhanlue Yang**)
   - [example] Add real func version of marching_square (by **lin-hitonami**)
   - [Lang] Support matrix return value for real function (by **lin-hitonami**)
   - [Lang] Support ndarray argument for real function (by **lin-hitonami**)
   - [ir] Let the type of ExternalTensorExpression be an ndarray struct (by **lin-hitonami**)
   - [lang] Record the element_type of the AnyArray (by **lin-hitonami**)
   - [ir] Let expand_exprs support expanding nested structs (by **lin-hitonami**)
   - [opengl] Add import of external OpenGL context. (#8185) (by **Sam**)
   - [Lang] Cast the scalar arguments and return values of ti.func if the type hints exist (#8193) (by **Lin Jiang**)
   - [Lang] Handle MatrixPtrStmt for uniquely_accessed_pointers() (#8165) (by **Zhanlue Yang**)
   - [gui] Refactor scene renderables (#8168) (by **Antonio Ferreras**)
   - [bug] Fix failed IR verification after ndarray clamp (#8181) (by **Ailing**)
   - [lang] Include argument name in error message (#8180) (by **Ailing**)
   - [Doc] Update documentation (#8089) (by **Zhao Liang**)
   - [Error] [bug] Warn before calling the external function (#8177) (by **Lin Jiang**)
   - [ci] Ghstack bot treats neutral checks as success and ignore copilot for PRs (#8174) (by **Xinhao Yuan**)
   - [Lang] Support struct arguments for real function (by **lin-hitonami**)
   - [opt] Run demote_atomics pass on real function (by **lin-hitonami**)
   - [refactor] [ir] Change Block::parent_kernel to parent_callable (by **lin-hitonami**)
   - [Doc] Update docstring for inverse func (#8170) (by **Zhao Liang**)
   - [doc] Added introduction to argument pack (#8164) (by **秋云未云**)
   - [opt] Treat FuncCallStmt better in store-to-load forwarding in CFG (#8155) (by **Lin Jiang**)
   - [test] Added test for argpack (by **listerily**)
   - [lang] [refactor] Support parameter passing for argpack (by **listerily**)
   - [bug] Fix sparse matrix memory release error (by **listerily**)
   - [lang] Added argpack as a new type (by **listerily**)
   - [lang] Added frontend type check for structs (by **listerily**)
   - [lang] Added type check for return value (by **listerily**)
   - [bug] Fix: entries cannot be used as a struct member name (by **listerily**)
   - [Error] Add option to print full traceback in Python (#8160) (by **Lin Jiang**)
   - [ci] Fix perf monitoring upload on releases (#8159) (by **Proton**)
   - [lang] Raise TaichiSyntaxError when there are default values in dataclasses (#8135) (by **秋云未云**)
   - [ci] Modify the release tests branch (#8153) (by **Xinhao Yuan**)
   - [aot] Fix unused args in cppgen (#8154) (by **Ailing**)
   - [lang] Support clamp type hint for ndarrays (#8136) (by **Ailing**)
   - [ci] Add /rerun-failed (#8152) (by **Xinhao Yuan**)
   - [misc] Add FrontendAllocaStmt::is_shared into offline cache key (#8145) (by **PGZXB**)
   - [ci] Add games201 in release tests (#8148) (by **Xinhao Yuan**)
   - [misc] Remove struct LlvmLaunchArgInfo (#8146) (by **PGZXB**)
   - [ci] Restart xserver before testing (#8142) (by **Xinhao Yuan**)
   - [opt] Properly handle FuncCallStmt in CFG and simplify passes (#8139) (by **Lin Jiang**)
   - [lang] Enforce dtype check for numpy arrays (#8141) (by **Ailing**)
   - [bug] Fix passing ndarray to a taichi function (#8138) (by **Lin Jiang**)
   - [metal] Support i64 with MSL2.3.0 (#8140) (by **Ailing**)
   - [gui] Fix for ImGui widget size on HiDPI (#8129) (by **Antonio Ferreras**)
   - [bug] Fix struct field error on bool on cuda (#8134) (by **秋云未云**)
   - [ir] [refactor] Let the type of Alloca be pointer (by **lin-hitonami**)
   - [ir] Update ASTBuilder for the refactor of Alloca (by **lin-hitonami**)
   - [ir] [refactor] Update passes for the refactor of Alloca (by **lin-hitonami**)
   - [ir] Update the codegen for the refactor of Alloca (by **lin-hitonami**)
   - [Error] Let to_primitive_type throw an error if the type is a pointer (by **lin-hitonami**)
   - [autodiff] Update autodiff for the refactor of Alloca (by **lin-hitonami**)
   - [refactor] [ir] Use get_rvalue_type in frontend IR instead of ret_type (by **lin-hitonami**)
   - [lang] Use get_rvalue_type instead of get_ret_type in python (by **lin-hitonami**)
   - [ir] Update get_rvalue_dtype and move it to class Expr (by **lin-hitonami**)
   - [aot] Misc fixes for cppgen (#8106) (by **Ailing**)
   - [misc] Print the IR after every sub-pass of full-simplify (#8127) (by **Lin Jiang**)
   - [gui] Per circle/particle radius (#8121) (by **Antonio Ferreras**)
   - [bug] Add parameter list and rets of Kernel into offline cache key (#8054) (by **PGZXB**)
   - [Bug] Fix incorrect CFG Graph structure due to missing Block wiith OffloadedStmts on LLVM backend (#8113) (by **Zhanlue Yang**)
   - [misc] Relax python_requires to play nice with poetry (#8116) (by **Proton**)
   - [test] Fix previous discovered flaky test_sparse_linear_solver.py. (#8110) (by **Qian Bao**)
   - [ir] Update ExpressionPrinter (by **Lin Jiang**)
   - [Bug] Fix type inference error with LowerMatrixPtr pass (#8105) (by **Zhanlue Yang**)
   - [Lang] Merge irpass::half2_vectorize() with irpass::scalarize() (#8102) (by **Zhanlue Yang**)
   - [bug] Fix: clang-tidy complaining explicit (#8109) (by **秋云未云**)
   - [Lang] Migrate irpass::scalarize() after optimize_bit_struct_stores & determine_ad_stack_size (#8097) (by **Zhanlue Yang**)
   - [bug] Fix MatrixFreeCG so it can handle multiple input sizes. (#8070) (by **Qian Bao**)
   - [bug] Fix SparseMatrix's dtype; check for dtype in SparseSolver. (#8071) (by **Qian Bao**)
   - [Lang] Migrate irpass::scalarize() after irpass::demote_operations() (#8096) (by **Zhanlue Yang**)
   - [bug] Fix compilation warning in constant fold on bool (#8100) (by **秋云未云**)
   - [Lang] Migrate irpass::scalarize() after irpass::lower_access() (#8091) (by **Zhanlue Yang**)
   - [Lang] Migrate irpass::scalarize() after irpass::make_block_local() (#8090) (by **Zhanlue Yang**)
   - [bug] Fix extraction of field with None offset to external array (#8093) (by **魔法少女赵志辉**)
   - [aot] Make generated tcm deterministic hash-wise (#8088) (by **Ailing**)
   - [Lang] Support TensorType for Dead-Store-Elimination (#8065) (by **Zhanlue Yang**)
   - [refactor] Get rid of unnecessary element_dim in ExternalPtrStmt (by **Ailing Zhang**)
   - [refactor] Get rid of unnecessary element_dim in ExternalTensorExpression (by **Ailing Zhang**)
   - [refactor] Rename dim to ndim for consistency in ExternalTensorExpression (by **Ailing Zhang**)
   - [Lang] Optimize alias checking conditions for store-to-load forwarding (#8079) (by **Zhanlue Yang**)
   - [ci] Fix Linux build image timezone (#8080) (by **Proton**)
   - [bug] Fix misbehaviour and assertion error on ti.math.sign (#8082) (by **秋云未云**)
   - [ci] Build.py polishing, wave 5 (#8073) (by **Proton**)
   - [refactor] Simplify ndarray arg declaration (by **Ailing Zhang**)
   - [refactor] Simplify ndarray impl by separating ndim and element_shape in (by **Ailing Zhang**)
   - [bug] Fix vector/matrix ndarray zero fill (#8068) (by **Ailing**)
   - [bug] Exclude quant type when doing store-to-load forwarding and skip bit struct store fusion when unfeasible (#8023) (by **魔法少女赵志辉**)
   - [build] Include Windows import lib in built wheel (#8067) (by **Proton**)
   - [bug] Fix: replaced i32 with bool in cook_dtype (by **listerily**)
   - [Lang] Support TensorType for Load-Store-Forwarding (#8058) (by **Zhanlue Yang**)
   - [doc] Added boolean to primitive types in docs (#8062) (by **秋云未云**)
   - [spirv] [ir] [lang] Support struct object as return value in spir-v (#8061) (by **秋云未云**)
   - [refactor] Get rid of element shape in runtime struct type of ndarray (by **Ailing Zhang**)
   - [refactor] Simplify ndarray type formation in llvm codegen (by **Ailing Zhang**)
   - [refactor] Simplify ndarray type formation in scalarize pass (by **Ailing Zhang**)
   - [Doc] Update type.md, add descriptions of the vector (#8048) (by **Chenzhan Shang**)
   - [Bug] Set initial value for Cuda device allocation (#8063) (by **Zhanlue Yang**)
   - [refactor] Return values on gfx passes through LaunchContextBuilder like llvm now (by **listerily**)
   - [Lang] Fix TensorTyped error with irpass::make_thread_local() (#8051) (by **Zhanlue Yang**)
   - [Lang] Fix numerical issue with auto_diff() (#8025) (by **Zhanlue Yang**)
   - Revert "[build] Fix build on arm64 (#7978)" (#8050) (by **Proton**)
   - [lang] Enable Kernel* access from Block in CHI IR (#8044) (by **Zhanlue Yang**)
   - [build] Fix build on arm64 (#7978) (by **Oliver Batchelor**)
   - [aot] [bug] Fix cached kernel name lookup (#8035) (by **Ailing**)
   - [Lang] Migrate irpass::scalarize() after irpass::make_mesh_block_local() (#8030) (by **Zhanlue Yang**)
   - [test] Temporarily skip tests/python/test_sparse_linear_solver.py. (#8038) (by **Qian Bao**)
   - [lang] [test] Fixed logical operation on numeric values and added support on real type (by **listerily**)
   - [test] Added test for bool operations (by **listerily**)
   - [lang] Added u1 as boolean type to taichi lang, replacing i32 (by **listerily**)
   - [ir] Fix: Updated type check for logical not (by **listerily**)
   - [ir] Constant fold support for u1 (by **listerily**)
   - [spirv] [ir] Support type u1 as arg, in buffer and as return value (by **listerily**)
   - [lang] [ir] Add logical and, logical or in ir (by **listerily**)
   - [lang] Support ti.types.vector and matrix as type annotation (by **Ailing Zhang**)
   - [Lang] Migrate irpass::scalarize() after irpass::make_thread_local() (#8028) (by **Zhanlue Yang**)
   - [cuda] Add fast intrinsics support to sin / cos / log (#7991) (by **Bob Cao**)
   - [ci] Fix nightly builds (#8022) (by **Proton**)
   - [lang] Update ticache to cache (#8020) (by **Nanase**)
   - [aot] Remove redundant copy of libtaichi_c_api.so to build (#8014) (by **Ailing**)
   - [cuda] Fix LLVM preallocate memory size calculation (#8000) (by **Bob Cao**)
   - [refactor] Simplify ndarray dtype check_match logic (by **Ailing Zhang**)
   - [refactor] Remove redundant TensorType class in python scope (by **Ailing Zhang**)
   - [Lang] Support allocate with cuda memory pool and reduce preallocation size accordingly (#7929) (by **Zhanlue Yang**)
   - [llvm] Simplified and add support for type u1 in logical not operation (by **listerily**)
   - [ir] Update codegen for `if` `while` `assert` to support type u1. (by **listerily**)
   - [lang] Added ti.u1 definition (by **listerily**)
   - [aot] Export aot kernels with decorator properly (#8016) (by **PENGUINLIONG**)
   - [Lang] Migrate irpass::scalarize() after irpass::demote_no_access_mesh_fors() (#7956) (by **Zhanlue Yang**)
   - [refactor] Let the type of reference arguments be a pointer (by **lin-hitonami**)
   - [Misc] Make clang-tidy happy on 'explicit' (#7999) (by **秋云未云**)
   - [Lang] Fix error with irpass::check_out_of_bound() for TensorTyped ExternalPtrStmt (#7997) (by **Zhanlue Yang**)
   - [Opengl] Fix: runtime caught error cannot be displayed in opengl (#7998) (by **秋云未云**)
   - [ci] Add dedicated build pipeline (by **Proton**)
   - [build] Guard Windows LTO with flags (by **Proton**)
   - [build] Use Ninja and MSVC to build on Windows (by **Proton**)
   - [build] Not generating PDB files by default (for compliation caching) (by **Proton**)
   - [ci] Tag wheel with TI_WITH_xxx tags (by **Proton**)
   - [ci] build.py: Add nice when compiling (by **Proton**)
   - [ci] Do not try to terminate sccache server after compilation (by **Proton**)
   - [misc] Do not print CHANGELOG when specified --save (make_changelog.py) (by **Proton**)
   - [Lang] Migrate irpass::scalarize() after irpass::demote_atomics() (#7943) (by **Zhanlue Yang**)
   - [Doc] Fix a bug in faq.md (#7992) (by **Zhao Liang**)
   - [Doc] Fix problems in type_system.md (#7949) (by **秋云未云**)
   - [refactor] Simplify arg_features logic for ndarray (#7974) (by **Ailing**)
   - [bug] Fix extraction of field with offset to external array (#7945) (by **魔法少女赵志辉**)
   - [autodiff] Support passing vector/matrix args in autodiff kernel (#7973) (by **Ailing**)
   - [lang] Fix failure with taichi_benchmark (#7975) (by **Zhanlue Yang**)
   - [doc] Update contents in linear_solver.md (#7967) (by **Qian Bao**)
   - [build] Guard  CLANG_EXECUTABLE verifications with TI_WITH_LLVM (#7969) (by **Zhanlue Yang**)
   - [refactor] [llvm] Allocate the runtime context for real functions on the stack (#7971) (by **Lin Jiang**)
   - [autodiff] Support passing requires_grad=True tensor to an arg with needs_grad=False (#7970) (by **Ailing**)
   - [CUDA] Warn driver version if it doesn't support memory pool. (#7912) (by **Haidong Lan**)
   - [autodiff] Support grad tensor in primal kernel (#7962) (by **Ailing**)
   - [lang] Improve misc error report related to passing ndarray to a kernel (#7966) (by **Ailing**)
   - [Doc] Add doc about struct arguments (#7959) (by **Lin Jiang**)
   - [Error] Update deprecation warning of the graph arguments (#7965) (by **Lin Jiang**)
   - [autodiff] Support ExternalTensorShapeAlongAxis in autodiff (#7963) (by **Ailing**)
   - [windows] Workaround C++ mangling special chars (#7964) (by **Ailing**)
   - [doc] Add sparse grid example. (#7858) (by **chunleili**)
   - [Lang] Separate out preallocation logics for runtime objects (#7938) (by **Zhanlue Yang**)
   - [Lang] Remove deprecated funcs in __init__.py (#7941) (by **Lin Jiang**)
   - [build] Remove redundant C-API shared object in wheel (#7950) (by **Proton**)
   - [Bug] [spirv] Fix the insertion position of the access chain (#7957) (by **Lin Jiang**)
   - [doc] Split linear solver article from sparse_matrix.md. (#7921) (by **Qian Bao**)
   - [Lang] Remove deprecated sparse_matrix_builder function (#7942) (by **Lin Jiang**)
   - [lang] Refactor cg solvers (#7911) (by **Qian Bao**)
   - [Lang] Remove deprecated compile option ndarray_use_cached_allocator (#7937) (by **Zhanlue Yang**)
   - [Lang] Migrate irpass::scalarize() after irpass::detect_read_only() (#7939) (by **Zhanlue Yang**)
   - [bug] Fix vector/matrix dtype created in the python scope (#7948) (by **Ailing**)
   - [Lang] Remove deprecated funcs in ti.ui (#7940) (by **Lin Jiang**)
   - [Lang] Remove the support for 'is' (#7930) (by **Lin Jiang**)
   - [Opt] Make merging casts int(int(x)) less aggressive (#7944) (by **Ailing**)
   - [Lang] Migrate irpass::scalarize() after irpass::offload() (#7919) (by **Zhanlue Yang**)
   - [Lang] Raise error when the dimension of the ndrange does not equal to the number of the loop variable (#7933) (by **Lin Jiang**)
   - [Lang] Remove a.atomic(b) (#7925) (by **Lin Jiang**)
   - [Opt] Fix redundant clone of stmts across offloaded tasks (#7927) (by **Ailing**)
   - [Lang] Cancel deprecating native min/max (#7928) (by **Lin Jiang**)
   - [Lang] Fix the api doc search problem (#7918) (by **Zhao Liang**)
   - [Refactor] Refactor the argument passing logic of rwtexture and remove extra_args (#7914) (by **Lin Jiang**)
   - [refactor] Let the matrix argument be compiled as a struct (by **lin-hitonami**)
   - [ci] Build.py: Source generated env in new spawned shell (by **Proton**)
   - [misc] Fix changelog commit extract code (by **Proton**)
   - [Doc] Fix docstring of mix function (#7922) (by **Zhao Liang**)
   - [ci] More robust build.py bootstrapping (#7920) (by **Proton**)
   - [example] PR apply for an example of differential algorithm (#7881) (by **Nanase**)
   - [lang] Postpone scalarization to after flag access (#7890) (by **魔法少女赵志辉**)
   - [refactor] Remove PyTaichi.compiled_functions (#7867) (by **PGZXB**)
   - [example] Fix ti example bugs (#7903) (by **Zhao Liang**)
   - [lang] Postpone scalarization to after out-of-bound checking (#7872) (by **魔法少女赵志辉**)
   - [Lang] Move irpass::scalarize() after irpass::auto_diff() (#7902) (by **Zhanlue Yang**)
   - [Lang] Fix Ndarray fill with Matrix/Vector typed values (#7901) (by **Zhanlue Yang**)
   - [autodiff] Make loss seed only set once in the tape (#7910) (by **Mingrui Zhang**)
   - [Lang] Add cast to field.fill() interface (#7899) (by **Zhanlue Yang**)
   - [Lang] [bug] Let nested data classes have methods (#7909) (by **Lin Jiang**)
   - [cuda] Only set CU_LIMIT_STACK_SIZE when necessary (#7906) (by **Ailing**)
   - [Lang] Let kernel argument support matrix nested in a struct (by **lin-hitonami**)
   - [autodiff] Fix missing grad with using torch tensor with tape (#7898) (by **Ailing**)
   - [lang] Support TensorType for AutoDiff (#7846) (by **Zhanlue Yang**)
   - [example] Raise warning message for ngp renderer (#7434) (by **Zhao Liang**)
   - [ci] Build.py: Do not try to bootstrap pip (too many issues) (#7897) (by **Proton**)
   - [ci] Update AMDGPU LLVM & base image (#7895) (by **Proton**)
   - [ci] Build.py quirks fix (#7894) (by **Proton**)
   - [test] Skip torch involved ad_ndarray tests if torch is not installed (#7893) (by **Proton**)
   - [refactor] Improve AMDGPU kernel launch logic for external arrays and ndarrays (#7883) (by **Zeyu Li**)
   - [autodiff] Enfore strict check for ndarrays when used in ti.ad.Tape (by **Ailing Zhang**)
   - [refactor] Get rid of has_grad in LaunchContextBuilder (by **Ailing Zhang**)
   - [refactor] Rename get_num_elements in StructType to get_flattened_num_elements (by **Ailing Zhang**)
   - [autodiff] Support autodiff for torch Tensor and taichi ndarray on CPU and CUDA (by **Ailing Zhang**)
   - [Bug] Fix wrong datatype size when writing to ndarray from Python scope (by **Ailing Zhang**)
   - [lang] Support 0 dim ndarray read & write in python scope (by **Ailing Zhang**)
   - [Doc] Update faq and ggui, and add them to CI (#7861) (by **Zhao Liang**)
   - [refactor] Replace TaichiLLVMContext::jit with LlvmRuntimeExecutor::jit_session_ (#7868) (by **PGZXB**)
   - [build] Remove unused apt pkg 'libmirclient-dev' to make 'build.py' run properly on ubuntu 22.04 (#7871) (by **Yu Zhang**)
   - [Lang] Support the functions of dataclass as kernel argument and return value (#7865) (by **Lin Jiang**)
   - [Lang] Fix a bug on PosixPath (#7860) (by **Zhao Liang**)
   - [refactor] Improve CUDA kernel launch logic for external arrays and ndarrays (by **Ailing Zhang**)
   - [spirv] Fix generating array type in SPIR-V (#7863) (by **Lin Jiang**)
   - [rhi] Remove `fetch_result_uint64` from device api (#7851) (by **Bob Cao**)
   - [lang] Add grad_ptr into ndarray struct (by **Ailing Zhang**)
   - [refactor] Get rid of unused is_grad in ArgLoadStmt (by **Ailing Zhang**)
   - [refactor] Split Program::compile() (#7847) (by **PGZXB**)
   - [ci] Polishing build.py, wave 4 (#7857) (by **Proton**)
   - [refactor] Add the shape of the Ndarray to the argument struct (by **lin-hitonami**)
   - [lang] [ir] Added atomic multiplication support for all backends (#7854) (by **秋云未云**)
   - [build] Use LLVM without zstd dependency on M1 Macs (#7856) (by **Proton**)
   - [sparse] Add sparse_grid (#7832) (by **chunleili**)
   - [bug] Fix rerun tests with offline cache (#7852) (by **PGZXB**)
   - [refactor] Compile the Ndarray argument to a struct (by **lin-hitonami**)
   - [spirv] Support struct as kernel argument (by **Lin Jiang**)
   - [doc] Update dev_install.md to reflect build.py usage (#7848) (by **Proton**)
   - [Lang] Postpone MatrixType scalarization to irpass::differentiation_validation_check() (#7839) (by **Zhanlue Yang**)
   - [ci] Polishing build.py, wave 3 (#7845) (by **Proton**)
   - [bug] Allow to re-write the offline cache files (by **PGZXB**)
   - [misc] Deserialize the offline cache structs on strict mode (by **PGZXB**)
   - [Lang] Postpone MatrixType scalarization to irpass::gather_meshfor_relation_types() (#7838) (by **Zhanlue Yang**)
   - [lang] Refactor allocation logic for SNodeTreeBufferManager (#7795) (by **Zhanlue Yang**)
   - [bug] Adjust build structure for RHI to resolve undefined symbol problem with window_system (#7827) (by **Zhanlue Yang**)
   - [lang] Postpone scalarize and lower_matrix_ptr to after full_simplify I (#7798) (by **Zhanlue Yang**)
   - [Doc] Add kernel sync doc (#7831) (by **Zhao Liang**)
   - [cc] Remove cc backend (by **lin-hitonami**)
   - [spirv] Fix the ret type of frexp (by **lin-hitonami**)
   - [misc] Bump version to v1.7.0 (#7841) (by **Proton**)
   - [lang] Rewrite scalarization for PrintStmt (#7835) (by **魔法少女赵志辉**)
